#ifndef __COMMS_H__
#define __COMMS_H__

int InitGSComms(void);
int CloseGSComms(void);
int GSFcn1(int);
int SendNibble(int);
int ReadWriteNibble(int);
int ReadWriteByte(int);
unsigned int ReadWrite16(unsigned int x);
unsigned long ReadWrite32(unsigned long);
int CheckGSPresence(void);

/*might want to make a more generic stream version*/
int UploadFile(FILE * infile, unsigned long address);

/*these are simple read/write types that do not initiate or close the comms
between read/write, send address & length 0 and reinitiate*/
unsigned long Read32(unsigned long address);
unsigned short Read16(unsigned long address);
unsigned char ReadByte(unsigned long address);
int Write32(unsigned long address, unsigned long value);
int Write16(unsigned long address, unsigned short value);
int WriteByte(unsigned long address, unsigned char value);

/*Gameshark Code Generator List functions*/
int AddActiveCode(unsigned long addy, unsigned short val);
long NumActiveCode(void);
/*TODO: add a retrieve, list, and delete feature*/


/*common errors*/
int erratta(int code);
#endif
