#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/*declarations imported from header*/
int InitGSComms(void);
int CloseGSComms(void);
int UploadFile(FILE * infile, unsigned long address);
int GSFcn1(int);
int SendNibble(int);
int ReadWriteNibble(int);
int ReadWriteByte(int);
unsigned int ReadWrite16(unsigned int x);
unsigned long ReadWrite32(unsigned long);
int CheckGSPresence(void);
/*these are simple read/write types that do not initiate or close the comms
between read/write, send address & length 0 and reinitiate*/
unsigned long Read32(unsigned long address);
unsigned short Read16(unsigned long address);
unsigned char ReadByte(unsigned long address);
int Write32(unsigned long address,unsigned long value);
int Write16(unsigned long address,unsigned short value);
/*Gameshark Code Generator List functions*/
int AddActiveCode(unsigned long addy, unsigned short val);

/*LPT port address.  Could request it and save it external*/
unsigned int LPT1=0x378;

int checkered();
int erratta(int code);
int grabbity(int reg);
int statistic(int reg);

int SendSetup(int reg);
int Patcho();
int PALcho();
/*Sorry ahead of time.  I'm a rambler
GE Setup Uploader - Demo
c/o Zoinkity (nefariousdogooder@yahoo.com)

Uploads setup files to GE.
If the upload routine isn't detected, patches the game with it.
*/

/*this is a slight convenience
it keeps track of whether the comms are connected 1=no, 0=yes
most times this isn't necessary, but it helps when aborting the program*/
int stateflag=1;

/*warning - this will probably get very ugly...*/
int main(int argc, char *argv[])
{int reg,c;

for(;;)
{

for(c=0;c==0;)                    /*main menu loop*/
   {system("CLS");
   printf("\nGE Setup Upload\n");
   fflush(stdin);
   printf("\n1\tPatch!");
   printf("\n2\tUpload Setup");
   printf("\n3\tNab Statistics");
   printf("\n4\tCurrent Positions");
   printf("\n---------\n-Any Other Key To Quit-\n");

   switch(getch())
      {case '1':
            c=1; break;
       case '2':
            c=2; break;
	 case '3':
		c=3; break;
	 case '4':
		c=4; break;
       default:
	       return 0;
       }
   }/*end menu loop*/

reg=checkered();
system("CLS");
fflush(stdin);

/*grab coordinates*/
if(c==4) grabbity(reg);

/*statistics*/
if(c==3) statistic(reg);

if(reg<1) erratta(6);     /*non-JAP only supported at the moment*/

/*upload setup*/
if(c==2) c=SendSetup(reg);

/*patch*/
if(c==1)
        {if(reg==1) Patcho();
        if(reg==2) PALcho();}

}/*end evil for loop of doom*/
}/*End main()*/


/*send a setup file to console
returns 0 if all is well,
        1 if the patch was not applied
        2 if filesize too large or just not in the loop
        -1 if some other glaring error*/
int SendSetup(int reg)
{char filename[255];
FILE *in;
unsigned long x;

if(reg<1) return 1;

/*grab filename*/
	strcpy(filename,"\0");
    while (!(in = fopen(filename, "rb"))) {
	printf("\nUpload what file? ");
    fflush(stdin);
	strcpy(filename,"\0");	
	gets(filename);
    }
/*check that file isn't too large*/ 
 fseek(in,0,SEEK_END);
 if(ftell(in)>0x19400)
   {erratta(4); return 2;}

/*test if loop active*/
if (InitGSComms()) return -1;
	ReadWriteByte(1);
	if(Read32(0x800003E0)!=0xBAADF00D)
      {if(reg==1) x=Read32(0x8001385C);
      else if(reg==2) x=Read32(0x8001308C);
      ReadWrite32(0);
      ReadWrite32(0);
      if(x!=0x080000D0) return 1;
      erratta(7); return 2;
      }

if(reg==1) x=Read32(0x8008D354);    /*address to upload setup to*/
else if(reg==2) x=Read32(0x80064C68);
ReadWrite32(0);
ReadWrite32(0);

if(x==0) erratta(3);
UploadFile(in,x);        /*uploads file and overwrites BADDF00D*/
CloseGSComms();

}

/*patch game
Ideally, would like to allow individual levels to be toggled on/off as available*/
int Patcho()
{char *filename="patch.bin";
FILE *in;
unsigned long x;
unsigned long lvl=0x0FFFFFFF;

/*missing is something to select what levels you want to be able to replace*/

/*it would be rather stupid if they didn't have the patch binary...*/
if(!(in=fopen(filename, "rb"))) erratta(8);

UploadFile(in,0x80000340);
fclose(in);
AddActiveCode(0xD002A8C3,0x0008);
AddActiveCode(0x810003E2,0xF00D);
InitGSComms();
ReadWriteByte(2);
Write32(0x8001385C,0x080000D0);
Write32(0x80013860,0x24002B30);
printf("\nI'm lazy.\nThis is going to allow all levels to be replaced.\nOrdinarily you'd ask which ones...\n");
if(lvl & 0x00000001) Write16(0x8003750A,0x5960);	/*BunkerI*/
if(lvl & 0x00000002) Write16(0x80037536,0x5960);	/*Silo*/
if(lvl & 0x00000004) Write16(0x8003753E,0x5960);	/*Statue Park*/
if(lvl & 0x00000008) Write16(0x80037542,0x5960);	/*Control*/
if(lvl & 0x00000010) Write16(0x80037546,0x5960);	/*Archives*/
if(lvl & 0x00000020) Write16(0x8003754A,0x5960);	/*Train*/
if(lvl & 0x00000040) Write16(0x8003754E,0x5960);	/*Frigate*/
if(lvl & 0x00000080) Write16(0x80037552,0x5960);	/*BunkerII*/
if(lvl & 0x00000100) Write16(0x80037556,0x5960);	/*Aztec*/
if(lvl & 0x00000200) Write16(0x8003755A,0x5960);	/*Streets*/
if(lvl & 0x00000400) Write16(0x8003755E,0x5960);	/*Depot*/
if(lvl & 0x00000800) Write16(0x80037562,0x5960);	/*Complex*/
if(lvl & 0x00001000) Write16(0x80037566,0x5960);	/*Egyptian*/
if(lvl & 0x00002000) Write16(0x8003756A,0x5960);	/*Dam*/
if(lvl & 0x00004000) Write16(0x8003756E,0x5960);	/*Facility*/
if(lvl & 0x00008000) Write16(0x80037572,0x5960);	/*Runway*/
if(lvl & 0x00010000) Write16(0x80037576,0x5960);	/*Suface I*/
if(lvl & 0x00020000) Write16(0x8003757A,0x5960);	/*Jungle*/
if(lvl & 0x00040000) Write16(0x8003757E,0x5960);	/*Temple*/
if(lvl & 0x00080000) Write16(0x80037582,0x5960);	/*Caverns*/
if(lvl & 0x00100000) Write16(0x80037586,0x5960);	/*Citadel*/
if(lvl & 0x00200000) Write16(0x8003758A,0x5960);	/*Cradle*/
if(lvl & 0x00400000) Write16(0x80037592,0x5960);	/*Surface II*/
if(lvl & 0x00800000) Write16(0x8003759A,0x5960);	/*Basement*/
if(lvl & 0x01000000) Write16(0x8003759E,0x5960);	/*Stacks*/
if(lvl & 0x02000000) Write16(0x800375A6,0x5960);	/*Library*/
if(lvl & 0x04000000) Write16(0x800375AE,0x5960);	/*Caves*/
if(lvl & 0x08000000) Write16(0x800375BE,0x5960);	/*Cuba*/
ReadWrite32(0);
ReadWrite32(0);
CloseGSComms();
printf("\n-and now for the MP-Patch...\n");
InitGSComms();
ReadWriteByte(2);
Write32(0x8005B260, 0x706A756E);
Write32(0x8005B264, 0x5A000000);
ReadWrite32(0);
ReadWrite32(0);
AddActiveCode(0xD002A8C3, 0x000E);
AddActiveCode(0x810003E2, 0xF00D);
AddActiveCode(0xD002A8C3, 0x0008);
AddActiveCode(0x81047D3A, 0xB258);
AddActiveCode(0xD002A8C3, 0x0008);
AddActiveCode(0x81047DBE, 0xB2E8);
AddActiveCode(0xD002A8C3, 0x000E);
AddActiveCode(0x81047D3A, 0xB2E8);
AddActiveCode(0xD002A8C3, 0x000E);
AddActiveCode(0x81047DBE, 0xB258);
CloseGSComms();
printf("\nPatched!  How cool is that?\n");
system("PAUSE");
return 0;}

/*Yes, I am quite aware of how ineffecient it is to repeat this garble...*/
int PALcho()
{char *filename="palch.bin";
FILE *in;
unsigned long x;
unsigned long lvl=0x0FFFFFFF;

/*missing is something to select what levels you want to be able to replace*/

/*it would be rather stupid if they didn't have the patch binary...*/
if(!(in=fopen(filename, "rb"))) erratta(8);

UploadFile(in,0x80000340);
fclose(in);
AddActiveCode(0xD0025E13,0x0008);
AddActiveCode(0x810003E2,0xF00D);
InitGSComms();
ReadWriteByte(2);
Write32(0x8001308C,0x080000D0);
Write32(0x80013090,0x24002B30);
printf("\nI'm lazy.\nThis is going to allow all levels to be replaced.\nOrdinarily you'd ask which ones...\n");
if(lvl & 0x00000001) Write16(0x800325BA,0xB020);	/*BunkerI*/
if(lvl & 0x00000002) Write16(0x800325E6,0xB020);	/*Silo*/
if(lvl & 0x00000004) Write16(0x800325EE,0xB020);	/*Statue Park*/
if(lvl & 0x00000008) Write16(0x800325F2,0xB020);	/*Control*/
if(lvl & 0x00000010) Write16(0x800325F6,0xB020);	/*Archives*/
if(lvl & 0x00000020) Write16(0x800325FA,0xB020);	/*Train*/
if(lvl & 0x00000040) Write16(0x800325FE,0xB020);	/*Frigate*/
if(lvl & 0x00000080) Write16(0x80032602,0xB020);	/*BunkerII*/
if(lvl & 0x00000100) Write16(0x80032606,0xB020);	/*Aztec*/
if(lvl & 0x00000200) Write16(0x8003260A,0xB020);	/*Streets*/
if(lvl & 0x00000400) Write16(0x8003260E,0xB020);	/*Depot*/
if(lvl & 0x00000800) Write16(0x80032612,0xB020);	/*Complex*/
if(lvl & 0x00001000) Write16(0x80032616,0xB020);	/*Egyptian*/
if(lvl & 0x00002000) Write16(0x8003261A,0xB020);	/*Dam*/
if(lvl & 0x00004000) Write16(0x8003261E,0xB020);	/*Facility*/
if(lvl & 0x00008000) Write16(0x80032622,0xB020);	/*Runway*/
if(lvl & 0x00010000) Write16(0x80032626,0xB020);	/*Suface I*/
if(lvl & 0x00020000) Write16(0x8003262A,0xB020);	/*Jungle*/
if(lvl & 0x00040000) Write16(0x8003262E,0xB020);	/*Temple*/
if(lvl & 0x00080000) Write16(0x80032632,0xB020);	/*Caverns*/
if(lvl & 0x00100000) Write16(0x80032636,0xB020);	/*Citadel*/
if(lvl & 0x00200000) Write16(0x8003263A,0xB020);	/*Cradle*/
if(lvl & 0x00400000) Write16(0x80032642,0xB020);	/*Surface II*/
if(lvl & 0x00800000) Write16(0x8003264A,0xB020);	/*Basement*/
if(lvl & 0x01000000) Write16(0x8003264E,0xB020);	/*Stacks*/
if(lvl & 0x02000000) Write16(0x80032656,0xB020);	/*Library*/
if(lvl & 0x04000000) Write16(0x8003265E,0xB020);	/*Caves*/
if(lvl & 0x08000000) Write16(0x8003266E,0xB020);	/*Cuba*/
ReadWrite32(0);
ReadWrite32(0);
CloseGSComms();
printf("\n-and now for the MP-Patch...\n");
InitGSComms();
ReadWriteByte(2);
Write32(0x8004FCB0, 0x706A756E);
Write32(0x8004FCB4, 0x5A000000);
ReadWrite32(0);
ReadWrite32(0);
AddActiveCode(0xD0025E13, 0x000E);
AddActiveCode(0x810003E2, 0xF00D);
AddActiveCode(0xD0025E13, 0x0008);
AddActiveCode(0x810407AA, 0xFCA8);
AddActiveCode(0xD0025E13, 0x0008);
AddActiveCode(0x8104082E, 0xFD38);
AddActiveCode(0xD0025E13, 0x000E);
AddActiveCode(0x810407AA, 0xFD38);
AddActiveCode(0xD0025E13, 0x000E);
AddActiveCode(0x8104082E, 0xFDA8);
CloseGSComms();
printf("\nPatched!  How cool is that?\n");
system("PAUSE");
return 0;}

/*game/region detection*/
int checkered()
{unsigned long x;
int reg;
/*region detection
you could check the rom header for region, or anything different really*/
/*do fakey checksum check for region - don't have full rom support yet*/
  printf("\nWait a second while some checks are run.\n");
  InitGSComms();
  ReadWriteByte(1);
  x=Read32(0xB0000010);
        
  /*NTSC Japan: reg=0*/
  if(x ==0xA24FA823) reg=0;

  /*NTSC North America: reg=1*/
  else if(x ==0xDCBC09FD) reg=1;
         
  /*PAL Europe: reg=2*/
  else if(x ==0x01142E57) reg=2;
  else reg=0xFF;

ReadWrite32(0);
ReadWrite32(0);
CloseGSComms();
return reg;}


/*common errors*/
int erratta(int code)
{switch(code)
       {default:/*unspecified for some reason*/
                break;
       case 0:  /*why did you call this again?*/
            return 0;
       case 1: /*failed init - timeout*/
             fprintf(stderr,"\nTimeout Error!\n");
             fprintf(stderr,"\nCan't connect to GS.\nCheck your cable and make sure code generator is ON.\nIf you're in the GS menus, exit them and try again");
             break;
       case 2:     /*failed init - Comms Not Detected*/
            fprintf(stderr,"\nComms Not Detected!\n");            
            fprintf(stderr,"\nCan't connect to GS.\nCheck your cable and make sure code generator is ON.\nIf you're in the GS menus, exit them and try again");
            break;
       case 3:    /*some sort of stupid data returned*/
            fprintf(stderr,"\nBad data!\n");
            fprintf(stderr,"\nThe data pulled is, well, screwy.  Can't say why\n");
            break;
       case 4:    /*shorten up your filenames! - nonterminal*/
            fprintf(stderr,"\nThat file is grumpy.  It is way too long.\n");
            fprintf(stderr,"\nThe longest setup file that can be transfered is 0x19400 bytes.\nIf that isn't large enough for you then I dont' know what is...\n");
            return 0;
       case 5:    /*can't let go of comms*/
            fprintf(stderr,"\nThe comms are buggered so they can't be disconnected\nSorry to say, you'll likely need to restart the game\nsorry for the inconvenience...\n");
            break;
       case 6:    /*Wrong game, or at least wrong version*/
            fprintf(stderr,"\nHmm...  Either this isn't Goldeneye, you have an unsupported version of the game, or the read failed miserably.");
            fprintf(stderr,"\nGrab the correct game and try again!\n");
            break;
       case 7:    /*Not in Loop - nonterminal*/
            fprintf(stderr,"\nYou either aren't in the loop or it didn't detect it.\n");
            fprintf(stderr,"\nSelect a stage ready for upload.  When the screen remains black and the music is playing, then try again.\n");
            return 0;
       case 8:    /*need patch binary in path*/
            fprintf(stderr,"\nYou need a hidden file - patch.bin - in the same folder as this program.\n");
            fprintf(stderr,"\nEither move it here or figure out what you did with it.\n");
            break;
       }

CloseGSComms();
outport(LPT1,0);
fprintf(stderr,"\naborting...\n");
system("PAUSE");
exit(1);
}

/**********************
Grabs Current Player Positions
**********************/
int grabbity(int reg)
{unsigned long addy,x,position;
short y,c;
unsigned char z;
float radian;
/*messy, but I'm sick of it not reading these properly*/
union goofy{long lg; float ft;} scale,pos;

/*region codes*/
unsigned long ScaleAddy[3]={0x80040F74,0x800413F4,0x8003AC44};
unsigned long BONDAddy[3]={0x80079F50,0x80079EE0,0x800689F0};
radian= M_PI;

  InitGSComms();
  ReadWriteByte(1);
  scale.lg=Read32(ScaleAddy[reg]);
  if(scale.lg==0) erratta(3);
for(c=0;c<4;c++)           /*messy, but it gets the job done*/
  {x=Read32(BONDAddy[reg]+(c * 4));   /*BONDdata offset*/
  if(x==0) continue;        /*continue if player data not available*/
  addy=Read32(x+0xA8);      /*offset to BOND8006*/
  if(addy==0) continue;        /*make sure they're loaded*/
  printf("Player %i data\t%08lX\t%08lX\n",c+1,x,addy);
  pos.lg=Read32(addy+0x8);
  position=pos.lg;
  pos.ft=(pos.ft * scale.ft);	/*rintf not implemented with this compiler*/
  printf("xpos\t%08lX\t%08lX\n",position,pos.lg);       /*x position*/
  pos.lg=Read32(addy+0xC);
  position=pos.lg;
  pos.ft=(pos.ft * scale.ft);	/*rintf not implemented with this compiler*/
  printf("ypos\t%08lX\t%08lX\n",position,pos.lg);       /*y position*/
  pos.lg=Read32(addy+0x10);
  position=pos.lg;
  pos.ft=(pos.ft * scale.ft);	/*rintf not implemented with this compiler*/
  printf("zpos\t%08lX\t%08lX\n",position,pos.lg);       /*z position*/
  scale.lg=Read32(x+0x148);
  position=scale.lg;
  pos.lg=Read32(x+0x158);
  printf("lateral\t%f deg.\tvertical\t%f deg.",scale.ft,pos.ft);
  if(scale.ft < 180) {
	if(scale.ft > 0) scale.ft*=-1.0;}
  scale.ft=sin(scale.ft * radian / 180) / radian * 180;
  pos.ft=sin(pos.ft * radian / 180) / radian * 180;
  printf("\nXrot\t%08lX\tYrot\t%08lX\t",scale.lg, pos.lg);
  scale.ft= sqrt(fabs((scale.ft * scale.ft)-1));
  pos.lg=position;
  if(pos.ft < 270 && pos.ft > 90) {
	if(scale.ft > 0) scale.ft*=-1.0;}
  printf("Zrot: %08lX\n",scale.lg);     /*z rotation*/
  x=Read32(addy+0x14);
  printf("room\t%08lX\t",x);       /*general room pointer*/
  if(x!=0)
    {y=Read16(x);
    z=ReadByte(x+2);
    printf("%04X%02X\tP%i%c",y,z,y,(z/8)+0x61);
    if(z%8) printf("%i",z%8);
     }
  printf("\n\n");
  }              /*end display info*/

  ReadWrite32(0);
  ReadWrite32(0);
  CloseGSComms();
  system("PAUSE");
return 0;}

/**********************
calculates and saves all those nifty statistics
accepts 'reg' indicating the addresses for each region game
Also saves stats to stats.txt
**********************/

int statistic(int reg)
{int c;
unsigned long addy,x;
union stupid{float ft; long lt;} y;
FILE *out;
int working=1;

unsigned long STATaddy[]={0x80079F60,0x80079EF0,0x80068A00};
unsigned long Players[]={0x8002B560,0x8002B523,0x80026A70};

if(!(out=fopen("stats.txt","wt"))) working=0;

    InitGSComms();
    ReadWriteByte(1);
    c=ReadByte(Players[reg]);
    addy=STATaddy[reg];

    for(;c>0;c--)/*display each set of stats*/
       {y.lt=Read32(addy+0x38);
       x=ReadByte(addy+0x69);
       printf("Player %i Statistics\t%08lX\n%sDistance Travelled: %f\n\n",3-c,addy,x>0 ? "Currently Control Flag/Golden Gun\n":"",y.ft);
	 if(working) fprintf(out,"Player %i Statistics\t%08lX\n%sDistance Travelled: %f\n\n",3-c,addy,x>0 ? "Currently Control Flag/Golden Gun\n":"",y.ft);
       printf("Shots Fired: %li\nHead:\t%li\tBody:\t%li\nLimb:\t%li\tOther:\t%li\nBack Shots and Explosions: %li\n",Read32(addy),Read32(addy+0x4),Read32(addy+0x8),Read32(addy+0xC),Read32(addy+0x10),Read32(addy+0x3C));
	 if(working) fprintf(out,"Shots Fired: %li\nHead:\t%li\tBody:\t%li\nLimb:\t%li\tOther:\t%li\nBack Shots and Explosions: %li\n",Read32(addy),Read32(addy+0x4),Read32(addy+0x8),Read32(addy+0xC),Read32(addy+0x10),Read32(addy+0x3C));
       y.lt=Read32(addy);
       if(y.lt!=0)          /*so long as you fired, pull some accuracy info*/
         {x=Read32(addy+0x4)+Read32(addy+0x8)+Read32(addy+0xC)+Read32(addy+0x10);
         x*=100;
         printf("Approximate Accuracy:\t%f\%\n",(float)x/(float)y.lt);
	   if(working) fprintf(out,"Approximate Accuracy:\t%f\%\n",(float)x/(float)y.lt);
         }
       x=Read32(addy+0x44)/60;
       printf("\nKills: %li\t-At Once %li\n%s:\t%li",Read32(addy+0x1C),Read32(addy+0x58),(3-c)==1 ? "Suicides":"Player 1",Read32(addy+0x24));
       printf("\t%s:\t%li",(3-c)==2 ? "Suicides":"Player 2",Read32(addy+0x28));
       printf("\n%s:\t%li",(3-c)==3 ? "Suicides":"Player 3",Read32(addy+0x2C));
       printf("\t%s:\t%li\nTime b/w Kills:\t",(3-c)==4 ? "Suicides":"Player 4",Read32(addy+0x30));
	 if(working) {
		fprintf(out,"\nKills: %li\t-At Once %li\n%s:\t%li",Read32(addy+0x1C),Read32(addy+0x58),(3-c)==1 ? "Suicides":"Player 1",Read32(addy+0x24));
		fprintf(out,"\t%s:\t%li",(3-c)==2 ? "Suicides":"Player 2",Read32(addy+0x28));
	fprintf(out,"\n%s:\t%li",(3-c)==3 ? "Suicides":"Player 3",Read32(addy+0x2C));
	fprintf(out,"\t%s:\t%li\nTime b/w Kills:\t",(3-c)==4 ? "Suicides":"Player 4",Read32(addy+0x30));}
       if(x!=0x2222222) {printf("%li:%02li\t",x/60,x%60);
				if(working) fprintf(out,"%li:%02li\t",x/60,x%60);}
       x=Read32(addy+0x48)/60;
       printf("%li:%02li",x/60,x%60);
	 if(working) fprintf(out,"%li:%02li",x/60,x%60);
       x=Read32(addy+0x4C)/60;
       printf("\n\nInnings:\t%li:%02li\t",x/60,x%60);
	 if(working) fprintf(out,"\n\nInnings:\t%li:%02li\t",x/60,x%60);
       x=Read32(addy+0x50)/60;
       if(x!=0x2222222) {printf("%li:%02li",x/60,x%60);
				if(working) fprintf(out,"%li:%02li",x/60,x%60);}
       x=Read32(addy+0x34)/60;
       printf("\nTime in Enemy's view:\t%li:%02li\n",x/60,x%60);
	 if(working) fprintf(out,"\nTime in Enemy's view:\t%li:%02li\n",x/60,x%60);
       x=Read32(addy+0x60)/60;
       y.lt=Read32(addy+0x40);
       printf("Flag Time:\t%li:%02li\nBody Armor Pickups: %.0f\n\n",x/60,x%60,y.ft);
	 if(working) {fprintf(out,"Flag Time:\t%li:%02li\nBody Armor Pickups: %.0f\n\n",x/60,x%60,y.ft);
			  working++;}
       system("PAUSE");
       system("CLS");
       addy+=0x70;
       }

ReadWrite32(0);/*clean up comms*/
ReadWrite32(0);
CloseGSComms();
fclose(out);
return 0;}

/*****************************************
Generic comms functions courtesy of hcs
http://sourceforge.net/projects/N64dev
nifty, eh?
*****************************************/

/*call to initialize comms
This locks the game and allows PC access
You must re-initialize between read/write to reset pipe*/
int InitGSComms() {
	int timeout=0x60;/*change this to fiddle with general timeout value*/
	while (GSFcn1(3) && timeout) {
		timeout--;
		/*15 second warning...*/
		if(timeout==0x40) printf("\ntimeout in:   %2d",timeout);
		if(timeout<=0x40) printf("\b\b%2d",timeout);
	}
	if (!timeout) erratta(1);
	if (!CheckGSPresence()) erratta(2);
	stateflag=0;
    return 0;
}

/*closing comms cuts the stream.
You only really need to do it when all access is complete
Therefore, read&write all day long, then kill stream at the very end*/
int CloseGSComms(void) {
    if (stateflag) return 0;
    stateflag=1;
	if (GSFcn1(3)|(!CheckGSPresence())) erratta(5);
	ReadWriteByte(0x64);
    outport(LPT1,0);      /*blank out the LPT*/
    return 0;
}

/*checks for sync*/
int GSFcn1(int x) {
	int timeout=0x28;
	unsigned char result;

	while (timeout) {
		result<<=4;
		result|=SendNibble(x);
		/* when we recieve a 6, then a 7, we're sync'd*/
		if (result==0x67) break;

		SendNibble(x);
		SendNibble(x>>4);

		timeout--;
	}

	if (!timeout) return 1;
	return 0;
}

int SendNibble(int x) {
	int timeout=0x3e8,retval;
	
	outport(LPT1,x&0xf|0x10);

	while (timeout && inport(LPT1+1)&8) timeout--;
	
	retval=(inport(LPT1+1)&0xf0^0x80)>>4;

	outport(LPT1,0);

	timeout=0x64;
	while (timeout && inport(LPT1+1)&8) timeout--;

	if (!timeout) return 0;
	else return retval;
}

int ReadWriteNibble(int x) {
	int retval;
	outport(LPT1,x&0xf|0x10);
	
	while ((~inport(LPT1+1))&8);
	while ((~inport(LPT1+1))&8);

	retval=(inport(LPT1+1)&0xf0^0x80)>>4;

	outport(LPT1,0);

	while (inport(LPT1+1)&8);
	while (inport(LPT1+1)&8);

	return retval;
}

int ReadWriteByte(int x) {
	return (ReadWriteNibble(x>>4)<<4)|ReadWriteNibble(x);
}

unsigned int ReadWrite16(unsigned int x) {
	return ((ReadWriteNibble(x>>12)<<12)|(ReadWriteNibble(x>>8)<<8)|(ReadWriteNibble(x>>4)<<4)|ReadWriteNibble(x));
}

unsigned long ReadWrite32(unsigned long x) {
	return ((unsigned long)ReadWriteNibble(x>>28)<<28)|((unsigned long)ReadWriteNibble(x>>24)<<24)|((unsigned long)ReadWriteNibble(x>>20)<<20)|((unsigned long)ReadWriteNibble(x>>16)<<16)|((unsigned long)ReadWriteNibble(x>>12)<<12)|((unsigned long)ReadWriteNibble(x>>8)<<8)|((unsigned long)ReadWriteNibble(x>>4)<<4)|(unsigned long)ReadWriteNibble(x);
}


/* this breaks when the GS can allow ram access*/
int CheckGSPresence(void) {
	int timeout=0x3e8,result;
	
	while (timeout) {
		result=(ReadWriteNibble(0x47>>4)<<4)|ReadWriteNibble(0x47);
		timeout--;
		if (result != 0x67) continue;
		result=(ReadWriteNibble(0x54>>4)<<4)|ReadWriteNibble(0x54);
		if (result == 0x74) break;
	}

/*	printf("\nGS utilities can't be used while in the GS menu.\n");*/
	if (timeout) return 1;
	return 0;
}

/*these are simple read/write types as above, but don't initiate or close the comms
  heck, they could probably just be implemented as macros if you get right to it...
  These are slightly faster, but the others are more robust*/
unsigned long Read32(unsigned long address) {
	ReadWrite32(address);
	ReadWrite32(4);
	return ReadWrite32(0);
}


unsigned short Read16(unsigned long address) {
	ReadWrite32(address);
	ReadWrite32(2);
	return ReadWrite16(0);
}

unsigned char ReadByte(unsigned long address)
{ReadWrite32(address);
ReadWrite32(1);
return ReadWriteByte(0);
}


int Write32(unsigned long address,unsigned long value) {

	ReadWrite32(address);
	ReadWrite32(4);
	
	ReadWrite32(value);

	return 0;
}

int Write16(unsigned long address,unsigned short value) {
	
	ReadWrite32(address);
	ReadWrite32(2);
	
	ReadWrite16(value);

	return 0;
}

/*File Upload*/
int UploadFile(FILE * infile, unsigned long address) {
	unsigned long c=0;
	unsigned long size;
	char buf;
	
	if (fseek(infile,0,SEEK_END)) return 1;
	size=ftell(infile);
	rewind(infile);

	if (InitGSComms()) return 1;

	printf("Uploading...00%%");

	ReadWriteByte(2);
	ReadWrite32(address);
	ReadWrite32(size);
	
	for (c=0; c < size; c++) {
		fread(&buf,1,1,infile);
		if (c & 0x400) printf("\b\b\b%2d%%",c*100/size);
		ReadWriteByte(buf);
	}

    Write32(0x800003E0,0);

	ReadWrite32(0);
	ReadWrite32(0);
	
	/*if (CloseGSComms()) return 1;*/

	printf("\b\b\bDone.\n");
	
	return 0;
}

/*Gameshark Code Generator List functions*/

/*add code to "active code" list
retrieve number of codes listed.
jump to point. (#codes * 6)
Send code, then update #

returns either number of codes in list or -1 if an error*/
int AddActiveCode(unsigned long addy, unsigned short val)
{unsigned long num;        /*number of codes in list*/

/*grab #codes currently in list*/
if (InitGSComms()) return -1;
	ReadWriteByte(1);
	num=Read32(0xA07E9D60);
	ReadWrite32(0);
	ReadWrite32(0);

/*write code*/
if (InitGSComms()) return -1;
   	ReadWriteByte(2);
    Write32(0xA07E9D64 + (num * 6),addy);
    Write16(0xA07E9D68 + (num * 6),val);
    Write32(0xA07E9D60,num + 1);
	ReadWrite32(0);
	ReadWrite32(0);

return num+1;}
